# Mobiprox

This repository hosts Mobiprox -- a framework enabling adaptable approximation of deep learning operations executed on the mobile platform. 
Mobiprox brings the following key contributions:
* Approximate computing primitives at the low-level of the mobile computing stack, supporting for both on-CPU and on-GPU approximate execution of different neural network operations; 
* End-to-end approximate configuration search and selection; For each layer in a deep neural network, Mobiprox determines an appropriate approximation level, so that the desired inference accuracy is reached. A Pareto front of the most appropriate configurations (per-layer approximations) that lead the the best energy-accuracy trade-off is then produced. 
* Compilation of approximate configuration into an Android-ready binary enabling application integration through JNI.
* Support for dynamic configuration loading with three alternative methods for runtime approximation configuration adaptation; our solutions ensure that the desired inference accuracy is achieved with the minimal use of a mobile’s resources.

## Work in progress

The project is in the pre-release state. 

Mobiprox builds upon [ApproxHPVM](https://gitlab.engr.illinois.edu/llvm/hpvm-release), so please get familiar with this project first. 

The key parts of Mobiprox are:
* [ApproxHPVM for Android](https://gitlab.com/MatevzFa/hpvm-release)
* [Neural network tuning, compiling, and profiling framework](https://github.com/MatevzFa/hpvm-tuning-android)
* [Android demo app](https://github.com/MatevzFa/android-approxhpvm-demo)

## Authors and acknowledgment
Mobiprox was initially developed by Matevz Fabjancic for his [MS thesis](https://repozitorij.uni-lj.si/Dokument.php?id=150611) at the Faculty of Computer and Information Science, University of Ljubljana under the guidance of Veljko Pejovic and the HPVM group from UIUC (Sasa Misailovic and Hashim Sharif).

## Citing

If using this code, please cite:

Fabjančič, M., Machidon, O., Sharif, H., Zhao, Y., Misailović, S., & Pejović, V. (2024). Mobiprox: Supporting Dynamic Approximate Computing on Mobiles. IEEE Internet of Things Journal.